[LeetCode] 499. The Maze III 迷宫 III
There is a ball in a maze with empty spaces and walls. The ball can go through empty spaces by rolling up (u), down (d), left (l) or right (r), but it won't stop rolling until hitting a wall. When the ball stops, it could choose the next direction. There is also a hole in this maze. The ball will drop into the hole if it rolls on to the hole.
Given the ball position, the hole position and the maze, find out how the ball could drop into the hole by moving the shortest distance. The distance is defined by the number of empty spaces traveled by the ball from the start position (excluded) to the hole (included). Output the moving directions by using 'u', 'd', 'l' and 'r'. Since there could be several different shortest ways, you should output the lexicographically smallest way. If the ball cannot reach the hole, output "impossible".
The maze is represented by a binary 2D array. 1 means the wall and 0 means the empty space. You may assume that the borders of the maze are all walls. The ball and the hole coordinates are represented by row and column indexes.
Example 1
Input 1: a maze represented by a 2D array 0 0 0 0 0 1 1 0 0 1 0 0 0 0 0 0 1 0 0 1 0 1 0 0 0 Input 2: ball coordinate (rowBall, colBall) = (4, 3) Input 3: hole coordinate (rowHole, colHole) = (0, 1) Output: "lul" Explanation: There are two shortest ways for the ball to drop into the hole. The first way is left -> up -> left, represented by "lul". The second way is up -> left, represented by 'ul'. Both ways have shortest distance 6, but the first way is lexicographically smaller because 'l' < 'u'. So the output is "lul".
Example 2
Input 1: a maze represented by a 2D array 0 0 0 0 0 1 1 0 0 1 0 0 0 0 0 0 1 0 0 1 0 1 0 0 0 Input 2: ball coordinate (rowBall, colBall) = (4, 3) Input 3: hole coordinate (rowHole, colHole) = (3, 0) Output: "impossible" Explanation: The ball cannot reach the hole.
Note:
- There is only one ball and one hole in the maze.
- Both the ball and hole exist on an empty space, and they will not be at the same position initially.
- The given maze does not contain border (like the red rectangle in the example pictures), but you could assume the border of the maze are all walls.
- The maze contains at least 2 empty spaces, and the width and the height of the maze won't exceed 30.
490. The Maze 和 505. The Maze II 迷宫 II 的变形,在二维空间中放了洞,用u, r, d, l 这四个字母来分别表示上右下左,求让球掉入洞中的最小移动距离的移动方向字符串。在步数相等的情况下,返回按字母排序最小的答案。
解法1: BFS
解法2: DFS
Java:BFS,时间复杂度O(m * n * Max(m,n)),空间复杂度O(mn)
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 | class Solution { class Point { int row, col, dist; public Point( int row, int col, int dist) { this .row = row; this .col = col; this .dist = dist; } } public String findShortestWay( int [][] maze, int [] ball, int [] hole) { if (maze == null || maze.length == 0 ) { return "" ; } int m = maze.length, n = maze[ 0 ].length; int [][] distance = new int [m][n]; for ( int i = 0 ; i < m; i++) { Arrays.fill(distance[i], Integer.MAX_VALUE); } distance[ball[ 0 ]][ball[ 1 ]] = 0 ; int [][] directions = {{- 1 , 0 }, { 1 , 0 }, { 0 , - 1 }, { 0 , 1 }}; String[] ways = { "u" , "d" , "l" , "r" }; Map<Integer, String> map = new HashMap<>(); Queue<Point> queue = new LinkedList<>(); queue.add( new Point(ball[ 0 ], ball[ 1 ], 0 )); findShortestWayByBFS(maze, queue, map, distance, hole, ways, directions); return map.containsKey(hole[ 0 ] * n + hole[ 1 ]) ? map.get(hole[ 0 ] * n + hole[ 1 ]) : "impossible" ; } public void findShortestWayByBFS( int [][] maze, Queue<Point> queue, Map<Integer, String> map, int [][] distance, int [] hole, String[] ways, int [][] directions) { int n = maze[ 0 ].length; while (!queue.isEmpty()) { Point curPoint = queue.remove(); for ( int i = 0 ; i < 4 ; i++) { int row = curPoint.row, col = curPoint.col, dist = curPoint.dist; String path = map.getOrDefault(row * n + col, "" ); while (isValid(row, col, maze, hole)) { row += directions[i][ 0 ]; col += directions[i][ 1 ]; ++dist; } if (row != hole[ 0 ] || col != hole[ 1 ]) { row -= directions[i][ 0 ]; col -= directions[i][ 1 ]; --dist; } path += ways[i]; if (dist < distance[row][col]) { distance[row][col] = dist; map.put(row * n + col, path); queue.add( new Point(row, col, dist)); } else if (dist == distance[row][col] && path.compareTo(map.getOrDefault(row * n + col, "" )) < 0 ) { map.put(row * n + col, path); queue.add( new Point(row, col, dist)); } } } } public boolean isValid( int row, int col, int [][] maze, int [] hole) { return row >= 0 && row < maze.length && col >= 0 && col < maze[ 0 ].length && maze[row][col] == 0 && (row != hole[ 0 ] || col != hole[ 1 ]); } } |
Java:
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 | public class Solution { public String findShortestWay( int [][] maze, int [] ball, int [] hole) { Queue<Point> queue = new LinkedList<>(); int row = maze.length; int col = maze[ 0 ].length; Point[][] points = new Point[row][col]; for ( int i = 0 ; i < row; i++) { for ( int j = 0 ; j < col; j++) { Point point = new Point(i, j); points[i][j] = point; if (i == hole[ 0 ] && j == hole[ 1 ]) { point.path = "impossible" ; } } } int [] dirX = { 0 , - 1 , 1 , 0 }; // d, l, r, u int [] dirY = { 1 , 0 , 0 , - 1 }; String[] dir = { "d" , "l" , "r" , "u" }; Point startPoint = points[ball[ 0 ]][ball[ 1 ]]; startPoint.dis = 0 ; queue.add(startPoint); while (!queue.isEmpty()) { Point point = queue.poll(); for ( int i = 0 ; i < 4 ; i++) { int x = point.x; int y = point.y; int dis = point.dis; String path = point.path; boolean inHole = false ; while (x >= 0 && x < row && y >= 0 && y < col && maze[x][y] == 0 ) { x += dirX[i]; y += dirY[i]; dis++; if (x == hole[ 0 ] && y == hole[ 1 ]) { inHole = true ; break ; } } if (!inHole) { x -= dirX[i]; y -= dirY[i]; dis--; } Point newPoint = points[x][y]; if (newPoint.dis > dis) { newPoint.dis = dis; newPoint.path = String.join( "" , point.path, dir[i]); if (!inHole) { queue.add(newPoint); } } else if (newPoint.dis == dis) { boolean updated = false ; String newPath = String.join( "" , point.path, dir[i]); for ( int k = 0 ; k < newPoint.path.length() && k < newPath.length(); k++) { if (newPoint.path.charAt(k) > newPath.charAt(k)) { updated = true ; newPoint.path = newPath; break ; } } if (!updated && newPoint.path.length() > newPath.length()) { newPoint.path = newPath; } } } } return points[hole[ 0 ]][hole[ 1 ]].path; } } class Point { int x; int y; String path; int dis; public Point( int x, int y) { this .x = x; this .y = y; this .path = "" ; this .dis = Integer.MAX_VALUE; } } |
C++:
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 | class Solution { public : string findShortestWay(vector<vector< int >>& maze, vector< int >& ball, vector< int >& hole) { int m = maze.size(), n = maze[0].size(); vector<vector< int >> dists(m, vector< int >(n, INT_MAX)); vector<vector< int >> dirs{{0,-1},{-1,0},{0,1},{1,0}}; vector< char > way{ 'l' , 'u' , 'r' , 'd' }; queue<pair< int , int >> q; unordered_map< int , string> u; dists[ball[0]][ball[1]] = 0; q.push({ball[0], ball[1]}); while (!q.empty()) { auto t = q.front(); q.pop(); for ( int i = 0; i < 4; ++i) { int x = t.first, y = t.second, dist = dists[x][y]; string path = u[x * n + y]; while (x >= 0 && x < m && y >= 0 && y < n && maze[x][y] == 0 && (x != hole[0] || y != hole[1])) { x += dirs[i][0]; y += dirs[i][1]; ++dist; } if (x != hole[0] || y != hole[1]) { x -= dirs[i][0]; y -= dirs[i][1]; --dist; } path.push_back(way[i]); if (dists[x][y] > dist) { dists[x][y] = dist; u[x * n + y] = path; if (x != hole[0] || y != hole[1]) q.push({x, y}); } else if (dists[x][y] == dist && u[x * n + y].compare(path) > 0) { u[x * n + y] = path; if (x != hole[0] || y != hole[1]) q.push({x, y}); } } } string res = u[hole[0] * n + hole[1]]; return res.empty() ? "impossible" : res; } }; |
C++: DFS
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 | class Solution { public : vector<vector< int >> dirs{{0,-1},{-1,0},{0,1},{1,0}}; vector< char > way{ 'l' , 'u' , 'r' , 'd' }; string findShortestWay(vector<vector< int >>& maze, vector< int >& ball, vector< int >& hole) { int m = maze.size(), n = maze[0].size(); vector<vector< int >> dists(m, vector< int >(n, INT_MAX)); unordered_map< int , string> u; dists[ball[0]][ball[1]] = 0; helper(maze, ball[0], ball[1], hole, dists, u); string res = u[hole[0] * n + hole[1]]; return res.empty() ? "impossible" : res; } void helper(vector<vector< int >>& maze, int i, int j, vector< int >& hole, vector<vector< int >>& dists, unordered_map< int , string>& u) { if (i == hole[0] && j == hole[1]) return ; int m = maze.size(), n = maze[0].size(); for ( int k = 0; k < 4; ++k) { int x = i, y = j, dist = dists[x][y]; string path = u[x * n + y]; while (x >= 0 && x < m && y >= 0 && y < n && maze[x][y] == 0 && (x != hole[0] || y != hole[1])) { x += dirs[k][0]; y += dirs[k][1]; ++dist; } if (x != hole[0] || y != hole[1]) { x -= dirs[k][0]; y -= dirs[k][1]; --dist; } path.push_back(way[k]); if (dists[x][y] > dist) { dists[x][y] = dist; u[x * n + y] = path; helper(maze, x, y, hole, dists, u); } else if (dists[x][y] == dist && u[x * n + y].compare(path) > 0) { u[x * n + y] = path; helper(maze, x, y, hole, dists, u); } } } }; |
类似题目:
[LeetCode] 505. The Maze II 迷宫 II
【推荐】国内首个AI IDE,深度理解中文开发场景,立即下载体验Trae
【推荐】编程新体验,更懂你的AI,立即体验豆包MarsCode编程助手
【推荐】抖音旗下AI助手豆包,你的智能百科全书,全免费不限次数
【推荐】轻量又高性能的 SSH 工具 IShell:AI 加持,快人一步
· 10年+ .NET Coder 心语,封装的思维:从隐藏、稳定开始理解其本质意义
· .NET Core 中如何实现缓存的预热?
· 从 HTTP 原因短语缺失研究 HTTP/2 和 HTTP/3 的设计差异
· AI与.NET技术实操系列:向量存储与相似性搜索在 .NET 中的实现
· 基于Microsoft.Extensions.AI核心库实现RAG应用
· 10年+ .NET Coder 心语 ── 封装的思维:从隐藏、稳定开始理解其本质意义
· 地球OL攻略 —— 某应届生求职总结
· 提示词工程——AI应用必不可少的技术
· Open-Sora 2.0 重磅开源!
· 周边上新:园子的第一款马克杯温暖上架